package QBWithDBInfo2;

import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Label;
import java.awt.Panel;
import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.Statement;

import quadbase.ChartAPI.DBInfo;
import quadbase.chart.designer.QbChartDesigner;
import quadbase.common.util.IDBConnection;
import quadbase.common.util.internal.IInterchange;
import quadbase.querybuilder.designer.QbQueryBuilder;



public class QBWithDBInfo2 extends Applet implements IInterchange, IDBConnection {
	static final long serialVersionUID = 1; 
	QbQueryBuilder queryMain;
	QbChartDesigner designer;
	String driver = "org.hsqldb.jdbcDriver";
	
	//provide real database info! The example Woodview database is located in the <InstallDir>/help/examples/DataSources/database directory
	String url = "jdbc:hsqldb:help/examples/DataSources/database/woodview";
	String username = "sa";
	String password = "";
	Connection conn;
	DatabaseMetaData metaData;
	
	String[] imagesPath = {"images", "backgroundImages"};

	static Applet applet;
	
	public static void main(java.lang.String[] args) {
		applet=null;
		try {
			new QBWithDBInfo2();
		} catch (Exception ex)
		{
			ex.printStackTrace();
		}

	}

	public void init() {

		try {
			applet=this;
			new QBWithDBInfo2();
			setLayout(new BorderLayout());
			Panel panel = new Panel();
			panel.setLayout(new BorderLayout());
			panel.add("Center", new Label("Loading"));
			add ("Center", panel);
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
	}
	
	public QBWithDBInfo2() throws Exception {
		QbChartDesigner.setServerAddress("127.0.0.1");
		QbChartDesigner.setServerPortNumber(22071);


		try {
			Class.forName(driver);
			conn = DriverManager.getConnection(url, username, password);
			metaData = conn.getMetaData();
		} catch (Exception ex) { ex.printStackTrace(); }

		queryMain = new QbQueryBuilder(null, this);
		queryMain.newQuery("Setup Query", this);
		queryMain.setVisible(true);

		try { queryMain.showTablesWindow();
		} catch (Exception ex) {};
	}

	public void back() {};

	public void cancel() {};

	public void next() {
		queryMain.getBuilder().setVisible(false);
		DBInfo dbInfo = new DBInfo(url, driver, username, password, queryMain.getSQL());
		designer = new QbChartDesigner(applet, dbInfo, queryMain.getInSet(), true, imagesPath);
		designer.setVisible(true);
	}

	public String getDatabaseProductName() throws Exception {

		return metaData.getDatabaseProductName();

	}

	public ResultSet getTables(String catalog, String schemPattern, String tableNamePattern, String[] types) throws Exception {

		return metaData.getTables(catalog, schemPattern, tableNamePattern, types);

	}

	public String getNumericFunctions() throws Exception {

		return metaData.getNumericFunctions();

	}

	public String getStringFunctions() throws Exception {

		return metaData.getStringFunctions();

	}

	public String getTimeDateFunctions() throws Exception {

		return metaData.getTimeDateFunctions();

	}

	public String getSystemFunctions() throws Exception {

		return metaData.getSystemFunctions();

	}

	public ResultSet executeQuery(String sql) throws Exception {

		Statement stmt = conn.createStatement();
		return stmt.executeQuery(sql);

	}

}